/*
 * This version waits in a loop, calling GetExitCodeProcess and Sleep
 * as suggested by hutch--. It lovers the thread priority as well while
 * waiting.
 *
 * Win2K: Shows CPU usage at 100%.
 */

#include <windows.h>

int shell(const char *lpfilename)
{
    PROCESS_INFORMATION pinfo;
    STARTUPINFO sinfo = { sizeof(STARTUPINFO) };
    BOOL bRet;
    int old_priority;
    int xc = -1;

    /* create process */
    bRet = CreateProcess(NULL, (char *)lpfilename, NULL, NULL,
                         FALSE, 0, NULL, NULL, &sinfo, &pinfo);

    if (!bRet) return -1;


    /* lower priority */
    old_priority = GetThreadPriority(GetCurrentThread());
    SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_IDLE);

    /* wait for process to terminate using hutch-- method */
    while (GetExitCodeProcess(pinfo.hProcess, &xc) &&
           (xc == STILL_ACTIVE)) Sleep(0);

    /* restore priority */
    SetThreadPriority(GetCurrentThread(), old_priority);

    /* close open handles */
    CloseHandle(pinfo.hProcess);
    CloseHandle(pinfo.hThread);

    /* return exit code */
    return xc;
}

int main()
{
    while (1) shell("client.exe");

    return 0;
}
